<!DOCTYPE html><html lang="en"><head><meta charset="utf-8"><meta name="viewport" content="width=device-width, initial-scale=1.0"><meta name="generator" content="rustdoc"><meta name="description" content="Source of the Rust file `/nix/store/kaan79bbbx80h17lcc5ay919l5r6bqlz-vendored-sources/object-0.29.0/src/common.rs`."><meta name="keywords" content="rust, rustlang, rust-lang"><title>common.rs - source</title><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceSerif4-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../FiraSans-Regular.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../FiraSans-Medium.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceCodePro-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceSerif4-Bold.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceCodePro-Semibold.ttf.woff2"><link rel="stylesheet" type="text/css" href="../../normalize.css"><link rel="stylesheet" type="text/css" href="../../rustdoc.css" id="mainThemeStyle"><link rel="stylesheet" type="text/css" href="../../ayu.css" disabled><link rel="stylesheet" type="text/css" href="../../dark.css" disabled><link rel="stylesheet" type="text/css" href="../../light.css" id="themeStyle"><script id="default-settings" ></script><script src="../../storage.js"></script><script defer src="../../source-script.js"></script><script defer src="../../source-files.js"></script><script defer src="../../main.js"></script><noscript><link rel="stylesheet" href="../../noscript.css"></noscript><link rel="alternate icon" type="image/png" href="../../favicon-16x16.png"><link rel="alternate icon" type="image/png" href="../../favicon-32x32.png"><link rel="icon" type="image/svg+xml" href="../../favicon.svg"></head><body class="rustdoc source"><!--[if lte IE 11]><div class="warning">This old browser is unsupported and will most likely display funky things.</div><![endif]--><nav class="mobile-topbar"><button class="sidebar-menu-toggle">&#9776;</button><a class="sidebar-logo" href="../../object/index.html"><div class="logo-container"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></div>
        </a><h2 class="location"></h2>
    </nav>
    <nav class="sidebar"><a class="sidebar-logo" href="../../object/index.html"><div class="logo-container"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></div>
        </a></nav><main><div class="width-limiter"><div class="sub-container"><a class="sub-logo-container" href="../../object/index.html"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></a><nav class="sub"><form class="search-form"><div class="search-container"><span></span><input class="search-input" name="search" autocomplete="off" spellcheck="false" placeholder="Click or press ‘S’ to search, ‘?’ for more options…" type="search"><div id="help-button" title="help" tabindex="-1"><button type="button">?</button></div><div id="settings-menu" tabindex="-1">
                                <a href="../../settings.html" title="settings"><img width="22" height="22" alt="Change settings" src="../../wheel.svg"></a></div>
                        </div></form></nav></div><section id="main-content" class="content"><div class="example-wrap"><pre class="line-numbers"><span id="1">1</span>
<span id="2">2</span>
<span id="3">3</span>
<span id="4">4</span>
<span id="5">5</span>
<span id="6">6</span>
<span id="7">7</span>
<span id="8">8</span>
<span id="9">9</span>
<span id="10">10</span>
<span id="11">11</span>
<span id="12">12</span>
<span id="13">13</span>
<span id="14">14</span>
<span id="15">15</span>
<span id="16">16</span>
<span id="17">17</span>
<span id="18">18</span>
<span id="19">19</span>
<span id="20">20</span>
<span id="21">21</span>
<span id="22">22</span>
<span id="23">23</span>
<span id="24">24</span>
<span id="25">25</span>
<span id="26">26</span>
<span id="27">27</span>
<span id="28">28</span>
<span id="29">29</span>
<span id="30">30</span>
<span id="31">31</span>
<span id="32">32</span>
<span id="33">33</span>
<span id="34">34</span>
<span id="35">35</span>
<span id="36">36</span>
<span id="37">37</span>
<span id="38">38</span>
<span id="39">39</span>
<span id="40">40</span>
<span id="41">41</span>
<span id="42">42</span>
<span id="43">43</span>
<span id="44">44</span>
<span id="45">45</span>
<span id="46">46</span>
<span id="47">47</span>
<span id="48">48</span>
<span id="49">49</span>
<span id="50">50</span>
<span id="51">51</span>
<span id="52">52</span>
<span id="53">53</span>
<span id="54">54</span>
<span id="55">55</span>
<span id="56">56</span>
<span id="57">57</span>
<span id="58">58</span>
<span id="59">59</span>
<span id="60">60</span>
<span id="61">61</span>
<span id="62">62</span>
<span id="63">63</span>
<span id="64">64</span>
<span id="65">65</span>
<span id="66">66</span>
<span id="67">67</span>
<span id="68">68</span>
<span id="69">69</span>
<span id="70">70</span>
<span id="71">71</span>
<span id="72">72</span>
<span id="73">73</span>
<span id="74">74</span>
<span id="75">75</span>
<span id="76">76</span>
<span id="77">77</span>
<span id="78">78</span>
<span id="79">79</span>
<span id="80">80</span>
<span id="81">81</span>
<span id="82">82</span>
<span id="83">83</span>
<span id="84">84</span>
<span id="85">85</span>
<span id="86">86</span>
<span id="87">87</span>
<span id="88">88</span>
<span id="89">89</span>
<span id="90">90</span>
<span id="91">91</span>
<span id="92">92</span>
<span id="93">93</span>
<span id="94">94</span>
<span id="95">95</span>
<span id="96">96</span>
<span id="97">97</span>
<span id="98">98</span>
<span id="99">99</span>
<span id="100">100</span>
<span id="101">101</span>
<span id="102">102</span>
<span id="103">103</span>
<span id="104">104</span>
<span id="105">105</span>
<span id="106">106</span>
<span id="107">107</span>
<span id="108">108</span>
<span id="109">109</span>
<span id="110">110</span>
<span id="111">111</span>
<span id="112">112</span>
<span id="113">113</span>
<span id="114">114</span>
<span id="115">115</span>
<span id="116">116</span>
<span id="117">117</span>
<span id="118">118</span>
<span id="119">119</span>
<span id="120">120</span>
<span id="121">121</span>
<span id="122">122</span>
<span id="123">123</span>
<span id="124">124</span>
<span id="125">125</span>
<span id="126">126</span>
<span id="127">127</span>
<span id="128">128</span>
<span id="129">129</span>
<span id="130">130</span>
<span id="131">131</span>
<span id="132">132</span>
<span id="133">133</span>
<span id="134">134</span>
<span id="135">135</span>
<span id="136">136</span>
<span id="137">137</span>
<span id="138">138</span>
<span id="139">139</span>
<span id="140">140</span>
<span id="141">141</span>
<span id="142">142</span>
<span id="143">143</span>
<span id="144">144</span>
<span id="145">145</span>
<span id="146">146</span>
<span id="147">147</span>
<span id="148">148</span>
<span id="149">149</span>
<span id="150">150</span>
<span id="151">151</span>
<span id="152">152</span>
<span id="153">153</span>
<span id="154">154</span>
<span id="155">155</span>
<span id="156">156</span>
<span id="157">157</span>
<span id="158">158</span>
<span id="159">159</span>
<span id="160">160</span>
<span id="161">161</span>
<span id="162">162</span>
<span id="163">163</span>
<span id="164">164</span>
<span id="165">165</span>
<span id="166">166</span>
<span id="167">167</span>
<span id="168">168</span>
<span id="169">169</span>
<span id="170">170</span>
<span id="171">171</span>
<span id="172">172</span>
<span id="173">173</span>
<span id="174">174</span>
<span id="175">175</span>
<span id="176">176</span>
<span id="177">177</span>
<span id="178">178</span>
<span id="179">179</span>
<span id="180">180</span>
<span id="181">181</span>
<span id="182">182</span>
<span id="183">183</span>
<span id="184">184</span>
<span id="185">185</span>
<span id="186">186</span>
<span id="187">187</span>
<span id="188">188</span>
<span id="189">189</span>
<span id="190">190</span>
<span id="191">191</span>
<span id="192">192</span>
<span id="193">193</span>
<span id="194">194</span>
<span id="195">195</span>
<span id="196">196</span>
<span id="197">197</span>
<span id="198">198</span>
<span id="199">199</span>
<span id="200">200</span>
<span id="201">201</span>
<span id="202">202</span>
<span id="203">203</span>
<span id="204">204</span>
<span id="205">205</span>
<span id="206">206</span>
<span id="207">207</span>
<span id="208">208</span>
<span id="209">209</span>
<span id="210">210</span>
<span id="211">211</span>
<span id="212">212</span>
<span id="213">213</span>
<span id="214">214</span>
<span id="215">215</span>
<span id="216">216</span>
<span id="217">217</span>
<span id="218">218</span>
<span id="219">219</span>
<span id="220">220</span>
<span id="221">221</span>
<span id="222">222</span>
<span id="223">223</span>
<span id="224">224</span>
<span id="225">225</span>
<span id="226">226</span>
<span id="227">227</span>
<span id="228">228</span>
<span id="229">229</span>
<span id="230">230</span>
<span id="231">231</span>
<span id="232">232</span>
<span id="233">233</span>
<span id="234">234</span>
<span id="235">235</span>
<span id="236">236</span>
<span id="237">237</span>
<span id="238">238</span>
<span id="239">239</span>
<span id="240">240</span>
<span id="241">241</span>
<span id="242">242</span>
<span id="243">243</span>
<span id="244">244</span>
<span id="245">245</span>
<span id="246">246</span>
<span id="247">247</span>
<span id="248">248</span>
<span id="249">249</span>
<span id="250">250</span>
<span id="251">251</span>
<span id="252">252</span>
<span id="253">253</span>
<span id="254">254</span>
<span id="255">255</span>
<span id="256">256</span>
<span id="257">257</span>
<span id="258">258</span>
<span id="259">259</span>
<span id="260">260</span>
<span id="261">261</span>
<span id="262">262</span>
<span id="263">263</span>
<span id="264">264</span>
<span id="265">265</span>
<span id="266">266</span>
<span id="267">267</span>
<span id="268">268</span>
<span id="269">269</span>
<span id="270">270</span>
<span id="271">271</span>
<span id="272">272</span>
<span id="273">273</span>
<span id="274">274</span>
<span id="275">275</span>
<span id="276">276</span>
<span id="277">277</span>
<span id="278">278</span>
<span id="279">279</span>
<span id="280">280</span>
<span id="281">281</span>
<span id="282">282</span>
<span id="283">283</span>
<span id="284">284</span>
<span id="285">285</span>
<span id="286">286</span>
<span id="287">287</span>
<span id="288">288</span>
<span id="289">289</span>
<span id="290">290</span>
<span id="291">291</span>
<span id="292">292</span>
<span id="293">293</span>
<span id="294">294</span>
<span id="295">295</span>
<span id="296">296</span>
<span id="297">297</span>
<span id="298">298</span>
<span id="299">299</span>
<span id="300">300</span>
<span id="301">301</span>
<span id="302">302</span>
<span id="303">303</span>
<span id="304">304</span>
<span id="305">305</span>
<span id="306">306</span>
<span id="307">307</span>
<span id="308">308</span>
<span id="309">309</span>
<span id="310">310</span>
<span id="311">311</span>
<span id="312">312</span>
<span id="313">313</span>
<span id="314">314</span>
<span id="315">315</span>
<span id="316">316</span>
<span id="317">317</span>
<span id="318">318</span>
<span id="319">319</span>
<span id="320">320</span>
<span id="321">321</span>
<span id="322">322</span>
<span id="323">323</span>
<span id="324">324</span>
<span id="325">325</span>
<span id="326">326</span>
<span id="327">327</span>
<span id="328">328</span>
<span id="329">329</span>
<span id="330">330</span>
<span id="331">331</span>
<span id="332">332</span>
<span id="333">333</span>
<span id="334">334</span>
<span id="335">335</span>
<span id="336">336</span>
<span id="337">337</span>
<span id="338">338</span>
<span id="339">339</span>
<span id="340">340</span>
<span id="341">341</span>
<span id="342">342</span>
<span id="343">343</span>
<span id="344">344</span>
<span id="345">345</span>
<span id="346">346</span>
<span id="347">347</span>
<span id="348">348</span>
<span id="349">349</span>
<span id="350">350</span>
<span id="351">351</span>
<span id="352">352</span>
<span id="353">353</span>
<span id="354">354</span>
<span id="355">355</span>
<span id="356">356</span>
<span id="357">357</span>
<span id="358">358</span>
<span id="359">359</span>
<span id="360">360</span>
<span id="361">361</span>
<span id="362">362</span>
<span id="363">363</span>
<span id="364">364</span>
<span id="365">365</span>
<span id="366">366</span>
<span id="367">367</span>
<span id="368">368</span>
<span id="369">369</span>
<span id="370">370</span>
<span id="371">371</span>
<span id="372">372</span>
<span id="373">373</span>
<span id="374">374</span>
<span id="375">375</span>
<span id="376">376</span>
<span id="377">377</span>
<span id="378">378</span>
<span id="379">379</span>
<span id="380">380</span>
<span id="381">381</span>
<span id="382">382</span>
<span id="383">383</span>
<span id="384">384</span>
<span id="385">385</span>
<span id="386">386</span>
<span id="387">387</span>
<span id="388">388</span>
<span id="389">389</span>
<span id="390">390</span>
<span id="391">391</span>
<span id="392">392</span>
<span id="393">393</span>
<span id="394">394</span>
<span id="395">395</span>
<span id="396">396</span>
<span id="397">397</span>
<span id="398">398</span>
<span id="399">399</span>
<span id="400">400</span>
<span id="401">401</span>
<span id="402">402</span>
<span id="403">403</span>
<span id="404">404</span>
<span id="405">405</span>
<span id="406">406</span>
<span id="407">407</span>
<span id="408">408</span>
<span id="409">409</span>
<span id="410">410</span>
<span id="411">411</span>
<span id="412">412</span>
<span id="413">413</span>
<span id="414">414</span>
<span id="415">415</span>
<span id="416">416</span>
<span id="417">417</span>
<span id="418">418</span>
<span id="419">419</span>
<span id="420">420</span>
<span id="421">421</span>
<span id="422">422</span>
<span id="423">423</span>
<span id="424">424</span>
<span id="425">425</span>
<span id="426">426</span>
<span id="427">427</span>
<span id="428">428</span>
<span id="429">429</span>
<span id="430">430</span>
<span id="431">431</span>
<span id="432">432</span>
<span id="433">433</span>
<span id="434">434</span>
<span id="435">435</span>
<span id="436">436</span>
<span id="437">437</span>
<span id="438">438</span>
<span id="439">439</span>
<span id="440">440</span>
<span id="441">441</span>
<span id="442">442</span>
<span id="443">443</span>
<span id="444">444</span>
<span id="445">445</span>
<span id="446">446</span>
<span id="447">447</span>
<span id="448">448</span>
<span id="449">449</span>
<span id="450">450</span>
</pre><pre class="rust"><code><span class="doccomment">/// A CPU architecture.</span>
<span class="attribute">#[<span class="ident">allow</span>(<span class="ident">missing_docs</span>)]</span>
<span class="attribute">#[<span class="ident">derive</span>(<span class="ident">Debug</span>, <span class="ident">Clone</span>, <span class="ident">Copy</span>, <span class="ident">PartialEq</span>, <span class="ident">Eq</span>, <span class="ident">Hash</span>)]</span>
<span class="attribute">#[<span class="ident">non_exhaustive</span>]</span>
<span class="kw">pub</span> <span class="kw">enum</span> <span class="ident">Architecture</span> {
    <span class="ident">Unknown</span>,
    <span class="ident">Aarch64</span>,
    <span class="ident">Arm</span>,
    <span class="ident">Avr</span>,
    <span class="ident">Bpf</span>,
    <span class="ident">I386</span>,
    <span class="ident">X86_64</span>,
    <span class="attribute">#[<span class="ident">allow</span>(<span class="ident">non_camel_case_types</span>)]</span>
    <span class="ident">X86_64_X32</span>,
    <span class="ident">Hexagon</span>,
    <span class="ident">LoongArch64</span>,
    <span class="ident">Mips</span>,
    <span class="ident">Mips64</span>,
    <span class="ident">Msp430</span>,
    <span class="ident">PowerPc</span>,
    <span class="ident">PowerPc64</span>,
    <span class="ident">Riscv32</span>,
    <span class="ident">Riscv64</span>,
    <span class="ident">S390x</span>,
    <span class="ident">Sparc64</span>,
    <span class="ident">Wasm32</span>,
}

<span class="kw">impl</span> <span class="ident">Architecture</span> {
    <span class="doccomment">/// The size of an address value for this architecture.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// Returns `None` for unknown architectures.</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">address_size</span>(<span class="self">self</span>) -&gt; <span class="prelude-ty">Option</span><span class="op">&lt;</span><span class="ident">AddressSize</span><span class="op">&gt;</span> {
        <span class="kw">match</span> <span class="self">self</span> {
            <span class="ident">Architecture::Unknown</span> =&gt; <span class="prelude-val">None</span>,
            <span class="ident">Architecture::Aarch64</span> =&gt; <span class="prelude-val">Some</span>(<span class="ident">AddressSize::U64</span>),
            <span class="ident">Architecture::Arm</span> =&gt; <span class="prelude-val">Some</span>(<span class="ident">AddressSize::U32</span>),
            <span class="ident">Architecture::Avr</span> =&gt; <span class="prelude-val">Some</span>(<span class="ident">AddressSize::U8</span>),
            <span class="ident">Architecture::Bpf</span> =&gt; <span class="prelude-val">Some</span>(<span class="ident">AddressSize::U64</span>),
            <span class="ident">Architecture::I386</span> =&gt; <span class="prelude-val">Some</span>(<span class="ident">AddressSize::U32</span>),
            <span class="ident">Architecture::X86_64</span> =&gt; <span class="prelude-val">Some</span>(<span class="ident">AddressSize::U64</span>),
            <span class="ident">Architecture::X86_64_X32</span> =&gt; <span class="prelude-val">Some</span>(<span class="ident">AddressSize::U32</span>),
            <span class="ident">Architecture::Hexagon</span> =&gt; <span class="prelude-val">Some</span>(<span class="ident">AddressSize::U32</span>),
            <span class="ident">Architecture::LoongArch64</span> =&gt; <span class="prelude-val">Some</span>(<span class="ident">AddressSize::U64</span>),
            <span class="ident">Architecture::Mips</span> =&gt; <span class="prelude-val">Some</span>(<span class="ident">AddressSize::U32</span>),
            <span class="ident">Architecture::Mips64</span> =&gt; <span class="prelude-val">Some</span>(<span class="ident">AddressSize::U64</span>),
            <span class="ident">Architecture::Msp430</span> =&gt; <span class="prelude-val">Some</span>(<span class="ident">AddressSize::U16</span>),
            <span class="ident">Architecture::PowerPc</span> =&gt; <span class="prelude-val">Some</span>(<span class="ident">AddressSize::U32</span>),
            <span class="ident">Architecture::PowerPc64</span> =&gt; <span class="prelude-val">Some</span>(<span class="ident">AddressSize::U64</span>),
            <span class="ident">Architecture::Riscv32</span> =&gt; <span class="prelude-val">Some</span>(<span class="ident">AddressSize::U32</span>),
            <span class="ident">Architecture::Riscv64</span> =&gt; <span class="prelude-val">Some</span>(<span class="ident">AddressSize::U64</span>),
            <span class="ident">Architecture::S390x</span> =&gt; <span class="prelude-val">Some</span>(<span class="ident">AddressSize::U64</span>),
            <span class="ident">Architecture::Sparc64</span> =&gt; <span class="prelude-val">Some</span>(<span class="ident">AddressSize::U64</span>),
            <span class="ident">Architecture::Wasm32</span> =&gt; <span class="prelude-val">Some</span>(<span class="ident">AddressSize::U32</span>),
        }
    }
}

<span class="doccomment">/// The size of an address value for an architecture.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// This may differ from the address size supported by the file format (such as for COFF).</span>
<span class="attribute">#[<span class="ident">allow</span>(<span class="ident">missing_docs</span>)]</span>
<span class="attribute">#[<span class="ident">derive</span>(<span class="ident">Debug</span>, <span class="ident">Clone</span>, <span class="ident">Copy</span>, <span class="ident">PartialEq</span>, <span class="ident">Eq</span>, <span class="ident">Hash</span>)]</span>
<span class="attribute">#[<span class="ident">non_exhaustive</span>]</span>
<span class="attribute">#[<span class="ident">repr</span>(<span class="ident">u8</span>)]</span>
<span class="kw">pub</span> <span class="kw">enum</span> <span class="ident">AddressSize</span> {
    <span class="ident">U8</span> <span class="op">=</span> <span class="number">1</span>,
    <span class="ident">U16</span> <span class="op">=</span> <span class="number">2</span>,
    <span class="ident">U32</span> <span class="op">=</span> <span class="number">4</span>,
    <span class="ident">U64</span> <span class="op">=</span> <span class="number">8</span>,
}

<span class="kw">impl</span> <span class="ident">AddressSize</span> {
    <span class="doccomment">/// The size in bytes of an address value.</span>
    <span class="attribute">#[<span class="ident">inline</span>]</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">bytes</span>(<span class="self">self</span>) -&gt; <span class="ident">u8</span> {
        <span class="self">self</span> <span class="kw">as</span> <span class="ident">u8</span>
    }
}

<span class="doccomment">/// A binary file format.</span>
<span class="attribute">#[<span class="ident">allow</span>(<span class="ident">missing_docs</span>)]</span>
<span class="attribute">#[<span class="ident">derive</span>(<span class="ident">Debug</span>, <span class="ident">Clone</span>, <span class="ident">Copy</span>, <span class="ident">PartialEq</span>, <span class="ident">Eq</span>, <span class="ident">Hash</span>)]</span>
<span class="attribute">#[<span class="ident">non_exhaustive</span>]</span>
<span class="kw">pub</span> <span class="kw">enum</span> <span class="ident">BinaryFormat</span> {
    <span class="ident">Coff</span>,
    <span class="ident">Elf</span>,
    <span class="ident">MachO</span>,
    <span class="ident">Pe</span>,
    <span class="ident">Wasm</span>,
}

<span class="doccomment">/// The kind of a section.</span>
<span class="attribute">#[<span class="ident">derive</span>(<span class="ident">Debug</span>, <span class="ident">Clone</span>, <span class="ident">Copy</span>, <span class="ident">PartialEq</span>, <span class="ident">Eq</span>, <span class="ident">Hash</span>)]</span>
<span class="attribute">#[<span class="ident">non_exhaustive</span>]</span>
<span class="kw">pub</span> <span class="kw">enum</span> <span class="ident">SectionKind</span> {
    <span class="doccomment">/// The section kind is unknown.</span>
    <span class="ident">Unknown</span>,
    <span class="doccomment">/// An executable code section.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// Example ELF sections: `.text`</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// Example Mach-O sections: `__TEXT/__text`</span>
    <span class="ident">Text</span>,
    <span class="doccomment">/// A data section.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// Example ELF sections: `.data`</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// Example Mach-O sections: `__DATA/__data`</span>
    <span class="ident">Data</span>,
    <span class="doccomment">/// A read only data section.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// Example ELF sections: `.rodata`</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// Example Mach-O sections: `__TEXT/__const`, `__DATA/__const`, `__TEXT/__literal4`</span>
    <span class="ident">ReadOnlyData</span>,
    <span class="doccomment">/// A loadable string section.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// Example ELF sections: `.rodata.str`</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// Example Mach-O sections: `__TEXT/__cstring`</span>
    <span class="ident">ReadOnlyString</span>,
    <span class="doccomment">/// An uninitialized data section.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// Example ELF sections: `.bss`</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// Example Mach-O sections: `__DATA/__bss`</span>
    <span class="ident">UninitializedData</span>,
    <span class="doccomment">/// An uninitialized common data section.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// Example Mach-O sections: `__DATA/__common`</span>
    <span class="ident">Common</span>,
    <span class="doccomment">/// A TLS data section.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// Example ELF sections: `.tdata`</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// Example Mach-O sections: `__DATA/__thread_data`</span>
    <span class="ident">Tls</span>,
    <span class="doccomment">/// An uninitialized TLS data section.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// Example ELF sections: `.tbss`</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// Example Mach-O sections: `__DATA/__thread_bss`</span>
    <span class="ident">UninitializedTls</span>,
    <span class="doccomment">/// A TLS variables section.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// This contains TLS variable structures, rather than the variable initializers.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// Example Mach-O sections: `__DATA/__thread_vars`</span>
    <span class="ident">TlsVariables</span>,
    <span class="doccomment">/// A non-loadable string section.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// Example ELF sections: `.comment`, `.debug_str`</span>
    <span class="ident">OtherString</span>,
    <span class="doccomment">/// Some other non-loadable section.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// Example ELF sections: `.debug_info`</span>
    <span class="ident">Other</span>,
    <span class="doccomment">/// Debug information.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// Example Mach-O sections: `__DWARF/__debug_info`</span>
    <span class="ident">Debug</span>,
    <span class="doccomment">/// Information for the linker.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// Example COFF sections: `.drectve`</span>
    <span class="ident">Linker</span>,
    <span class="doccomment">/// ELF note section.</span>
    <span class="ident">Note</span>,
    <span class="doccomment">/// Metadata such as symbols or relocations.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// Example ELF sections: `.symtab`, `.strtab`, `.group`</span>
    <span class="ident">Metadata</span>,
    <span class="doccomment">/// Some other ELF section type.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// This is the `sh_type` field in the section header.</span>
    <span class="doccomment">/// The meaning may be dependent on the architecture.</span>
    <span class="ident">Elf</span>(<span class="ident">u32</span>),
}

<span class="kw">impl</span> <span class="ident">SectionKind</span> {
    <span class="doccomment">/// Return true if this section contains zerofill data.</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">is_bss</span>(<span class="self">self</span>) -&gt; <span class="ident">bool</span> {
        <span class="self">self</span> <span class="op">==</span> <span class="ident">SectionKind::UninitializedData</span>
            <span class="op">|</span><span class="op">|</span> <span class="self">self</span> <span class="op">==</span> <span class="ident">SectionKind::UninitializedTls</span>
            <span class="op">|</span><span class="op">|</span> <span class="self">self</span> <span class="op">==</span> <span class="ident">SectionKind::Common</span>
    }
}

<span class="doccomment">/// The selection kind for a COMDAT section group.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// This determines the way in which the linker resolves multiple definitions of the COMDAT</span>
<span class="doccomment">/// sections.</span>
<span class="attribute">#[<span class="ident">derive</span>(<span class="ident">Debug</span>, <span class="ident">Clone</span>, <span class="ident">Copy</span>, <span class="ident">PartialEq</span>, <span class="ident">Eq</span>, <span class="ident">Hash</span>)]</span>
<span class="attribute">#[<span class="ident">non_exhaustive</span>]</span>
<span class="kw">pub</span> <span class="kw">enum</span> <span class="ident">ComdatKind</span> {
    <span class="doccomment">/// The selection kind is unknown.</span>
    <span class="ident">Unknown</span>,
    <span class="doccomment">/// Multiple definitions are allowed.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// An arbitrary definition is selected, and the rest are removed.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// This is the only supported selection kind for ELF.</span>
    <span class="ident">Any</span>,
    <span class="doccomment">/// Multiple definitions are not allowed.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// This is used to group sections without allowing duplicates.</span>
    <span class="ident">NoDuplicates</span>,
    <span class="doccomment">/// Multiple definitions must have the same size.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// An arbitrary definition is selected, and the rest are removed.</span>
    <span class="ident">SameSize</span>,
    <span class="doccomment">/// Multiple definitions must match exactly.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// An arbitrary definition is selected, and the rest are removed.</span>
    <span class="ident">ExactMatch</span>,
    <span class="doccomment">/// Multiple definitions are allowed, and the largest is selected.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// An arbitrary definition with the largest size is selected, and the rest are removed.</span>
    <span class="ident">Largest</span>,
    <span class="doccomment">/// Multiple definitions are allowed, and the newest is selected.</span>
    <span class="ident">Newest</span>,
}

<span class="doccomment">/// The kind of a symbol.</span>
<span class="attribute">#[<span class="ident">derive</span>(<span class="ident">Debug</span>, <span class="ident">Clone</span>, <span class="ident">Copy</span>, <span class="ident">PartialEq</span>, <span class="ident">Eq</span>, <span class="ident">Hash</span>)]</span>
<span class="attribute">#[<span class="ident">non_exhaustive</span>]</span>
<span class="kw">pub</span> <span class="kw">enum</span> <span class="ident">SymbolKind</span> {
    <span class="doccomment">/// The symbol kind is unknown.</span>
    <span class="ident">Unknown</span>,
    <span class="doccomment">/// The symbol is a null placeholder.</span>
    <span class="ident">Null</span>,
    <span class="doccomment">/// The symbol is for executable code.</span>
    <span class="ident">Text</span>,
    <span class="doccomment">/// The symbol is for a data object.</span>
    <span class="ident">Data</span>,
    <span class="doccomment">/// The symbol is for a section.</span>
    <span class="ident">Section</span>,
    <span class="doccomment">/// The symbol is the name of a file. It precedes symbols within that file.</span>
    <span class="ident">File</span>,
    <span class="doccomment">/// The symbol is for a code label.</span>
    <span class="ident">Label</span>,
    <span class="doccomment">/// The symbol is for a thread local storage entity.</span>
    <span class="ident">Tls</span>,
}

<span class="doccomment">/// A symbol scope.</span>
<span class="attribute">#[<span class="ident">derive</span>(<span class="ident">Debug</span>, <span class="ident">Clone</span>, <span class="ident">Copy</span>, <span class="ident">PartialEq</span>, <span class="ident">Eq</span>, <span class="ident">Hash</span>)]</span>
<span class="kw">pub</span> <span class="kw">enum</span> <span class="ident">SymbolScope</span> {
    <span class="doccomment">/// Unknown scope.</span>
    <span class="ident">Unknown</span>,
    <span class="doccomment">/// Symbol is visible to the compilation unit.</span>
    <span class="ident">Compilation</span>,
    <span class="doccomment">/// Symbol is visible to the static linkage unit.</span>
    <span class="ident">Linkage</span>,
    <span class="doccomment">/// Symbol is visible to dynamically linked objects.</span>
    <span class="ident">Dynamic</span>,
}

<span class="doccomment">/// The operation used to calculate the result of the relocation.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// The relocation descriptions use the following definitions. Note that</span>
<span class="doccomment">/// these definitions probably don&#39;t match any ELF ABI.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// * A - The value of the addend.</span>
<span class="doccomment">/// * G - The address of the symbol&#39;s entry within the global offset table.</span>
<span class="doccomment">/// * L - The address of the symbol&#39;s entry within the procedure linkage table.</span>
<span class="doccomment">/// * P - The address of the place of the relocation.</span>
<span class="doccomment">/// * S - The address of the symbol.</span>
<span class="doccomment">/// * GotBase - The address of the global offset table.</span>
<span class="doccomment">/// * Image - The base address of the image.</span>
<span class="doccomment">/// * Section - The address of the section containing the symbol.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// &#39;XxxRelative&#39; means &#39;Xxx + A - P&#39;.  &#39;XxxOffset&#39; means &#39;S + A - Xxx&#39;.</span>
<span class="attribute">#[<span class="ident">derive</span>(<span class="ident">Debug</span>, <span class="ident">Clone</span>, <span class="ident">Copy</span>, <span class="ident">PartialEq</span>, <span class="ident">Eq</span>, <span class="ident">Hash</span>)]</span>
<span class="attribute">#[<span class="ident">non_exhaustive</span>]</span>
<span class="kw">pub</span> <span class="kw">enum</span> <span class="ident">RelocationKind</span> {
    <span class="doccomment">/// S + A</span>
    <span class="ident">Absolute</span>,
    <span class="doccomment">/// S + A - P</span>
    <span class="ident">Relative</span>,
    <span class="doccomment">/// G + A - GotBase</span>
    <span class="ident">Got</span>,
    <span class="doccomment">/// G + A - P</span>
    <span class="ident">GotRelative</span>,
    <span class="doccomment">/// GotBase + A - P</span>
    <span class="ident">GotBaseRelative</span>,
    <span class="doccomment">/// S + A - GotBase</span>
    <span class="ident">GotBaseOffset</span>,
    <span class="doccomment">/// L + A - P</span>
    <span class="ident">PltRelative</span>,
    <span class="doccomment">/// S + A - Image</span>
    <span class="ident">ImageOffset</span>,
    <span class="doccomment">/// S + A - Section</span>
    <span class="ident">SectionOffset</span>,
    <span class="doccomment">/// The index of the section containing the symbol.</span>
    <span class="ident">SectionIndex</span>,
    <span class="doccomment">/// Some other ELF relocation. The value is dependent on the architecture.</span>
    <span class="ident">Elf</span>(<span class="ident">u32</span>),
    <span class="doccomment">/// Some other Mach-O relocation. The value is dependent on the architecture.</span>
    <span class="ident">MachO</span> {
        <span class="doccomment">/// The relocation type.</span>
        <span class="ident">value</span>: <span class="ident">u8</span>,
        <span class="doccomment">/// Whether the relocation is relative to the place.</span>
        <span class="ident">relative</span>: <span class="ident">bool</span>,
    },
    <span class="doccomment">/// Some other COFF relocation. The value is dependent on the architecture.</span>
    <span class="ident">Coff</span>(<span class="ident">u16</span>),
}

<span class="doccomment">/// Information about how the result of the relocation operation is encoded in the place.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// This is usually architecture specific, such as specifying an addressing mode or</span>
<span class="doccomment">/// a specific instruction.</span>
<span class="attribute">#[<span class="ident">derive</span>(<span class="ident">Debug</span>, <span class="ident">Clone</span>, <span class="ident">Copy</span>, <span class="ident">PartialEq</span>, <span class="ident">Eq</span>, <span class="ident">Hash</span>)]</span>
<span class="attribute">#[<span class="ident">non_exhaustive</span>]</span>
<span class="kw">pub</span> <span class="kw">enum</span> <span class="ident">RelocationEncoding</span> {
    <span class="doccomment">/// Generic encoding.</span>
    <span class="ident">Generic</span>,

    <span class="doccomment">/// x86 sign extension at runtime.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// Used with `RelocationKind::Absolute`.</span>
    <span class="ident">X86Signed</span>,
    <span class="doccomment">/// x86 rip-relative addressing.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// The `RelocationKind` must be PC relative.</span>
    <span class="ident">X86RipRelative</span>,
    <span class="doccomment">/// x86 rip-relative addressing in movq instruction.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// The `RelocationKind` must be PC relative.</span>
    <span class="ident">X86RipRelativeMovq</span>,
    <span class="doccomment">/// x86 branch instruction.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// The `RelocationKind` must be PC relative.</span>
    <span class="ident">X86Branch</span>,

    <span class="doccomment">/// s390x PC-relative offset shifted right by one bit.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// The `RelocationKind` must be PC relative.</span>
    <span class="ident">S390xDbl</span>,

    <span class="doccomment">/// AArch64 call target.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// The `RelocationKind` must be PC relative.</span>
    <span class="ident">AArch64Call</span>,
}

<span class="doccomment">/// File flags that are specific to each file format.</span>
<span class="attribute">#[<span class="ident">derive</span>(<span class="ident">Debug</span>, <span class="ident">Clone</span>, <span class="ident">Copy</span>, <span class="ident">PartialEq</span>, <span class="ident">Eq</span>, <span class="ident">Hash</span>)]</span>
<span class="attribute">#[<span class="ident">non_exhaustive</span>]</span>
<span class="kw">pub</span> <span class="kw">enum</span> <span class="ident">FileFlags</span> {
    <span class="doccomment">/// No file flags.</span>
    <span class="prelude-val">None</span>,
    <span class="doccomment">/// ELF file flags.</span>
    <span class="ident">Elf</span> {
        <span class="doccomment">/// `os_abi` field in the ELF file header.</span>
        <span class="ident">os_abi</span>: <span class="ident">u8</span>,
        <span class="doccomment">/// `abi_version` field in the ELF file header.</span>
        <span class="ident">abi_version</span>: <span class="ident">u8</span>,
        <span class="doccomment">/// `e_flags` field in the ELF file header.</span>
        <span class="ident">e_flags</span>: <span class="ident">u32</span>,
    },
    <span class="doccomment">/// Mach-O file flags.</span>
    <span class="ident">MachO</span> {
        <span class="doccomment">/// `flags` field in the Mach-O file header.</span>
        <span class="ident">flags</span>: <span class="ident">u32</span>,
    },
    <span class="doccomment">/// COFF file flags.</span>
    <span class="ident">Coff</span> {
        <span class="doccomment">/// `Characteristics` field in the COFF file header.</span>
        <span class="ident">characteristics</span>: <span class="ident">u16</span>,
    },
}

<span class="doccomment">/// Segment flags that are specific to each file format.</span>
<span class="attribute">#[<span class="ident">derive</span>(<span class="ident">Debug</span>, <span class="ident">Clone</span>, <span class="ident">Copy</span>, <span class="ident">PartialEq</span>, <span class="ident">Eq</span>, <span class="ident">Hash</span>)]</span>
<span class="attribute">#[<span class="ident">non_exhaustive</span>]</span>
<span class="kw">pub</span> <span class="kw">enum</span> <span class="ident">SegmentFlags</span> {
    <span class="doccomment">/// No segment flags.</span>
    <span class="prelude-val">None</span>,
    <span class="doccomment">/// ELF segment flags.</span>
    <span class="ident">Elf</span> {
        <span class="doccomment">/// `p_flags` field in the segment header.</span>
        <span class="ident">p_flags</span>: <span class="ident">u32</span>,
    },
    <span class="doccomment">/// Mach-O segment flags.</span>
    <span class="ident">MachO</span> {
        <span class="doccomment">/// `flags` field in the segment header.</span>
        <span class="ident">flags</span>: <span class="ident">u32</span>,
        <span class="doccomment">/// `maxprot` field in the segment header.</span>
        <span class="ident">maxprot</span>: <span class="ident">u32</span>,
        <span class="doccomment">/// `initprot` field in the segment header.</span>
        <span class="ident">initprot</span>: <span class="ident">u32</span>,
    },
    <span class="doccomment">/// COFF segment flags.</span>
    <span class="ident">Coff</span> {
        <span class="doccomment">/// `Characteristics` field in the segment header.</span>
        <span class="ident">characteristics</span>: <span class="ident">u32</span>,
    },
}

<span class="doccomment">/// Section flags that are specific to each file format.</span>
<span class="attribute">#[<span class="ident">derive</span>(<span class="ident">Debug</span>, <span class="ident">Clone</span>, <span class="ident">Copy</span>, <span class="ident">PartialEq</span>, <span class="ident">Eq</span>, <span class="ident">Hash</span>)]</span>
<span class="attribute">#[<span class="ident">non_exhaustive</span>]</span>
<span class="kw">pub</span> <span class="kw">enum</span> <span class="ident">SectionFlags</span> {
    <span class="doccomment">/// No section flags.</span>
    <span class="prelude-val">None</span>,
    <span class="doccomment">/// ELF section flags.</span>
    <span class="ident">Elf</span> {
        <span class="doccomment">/// `sh_flags` field in the section header.</span>
        <span class="ident">sh_flags</span>: <span class="ident">u64</span>,
    },
    <span class="doccomment">/// Mach-O section flags.</span>
    <span class="ident">MachO</span> {
        <span class="doccomment">/// `flags` field in the section header.</span>
        <span class="ident">flags</span>: <span class="ident">u32</span>,
    },
    <span class="doccomment">/// COFF section flags.</span>
    <span class="ident">Coff</span> {
        <span class="doccomment">/// `Characteristics` field in the section header.</span>
        <span class="ident">characteristics</span>: <span class="ident">u32</span>,
    },
}

<span class="doccomment">/// Symbol flags that are specific to each file format.</span>
<span class="attribute">#[<span class="ident">derive</span>(<span class="ident">Debug</span>, <span class="ident">Clone</span>, <span class="ident">Copy</span>, <span class="ident">PartialEq</span>, <span class="ident">Eq</span>, <span class="ident">Hash</span>)]</span>
<span class="attribute">#[<span class="ident">non_exhaustive</span>]</span>
<span class="kw">pub</span> <span class="kw">enum</span> <span class="ident">SymbolFlags</span><span class="op">&lt;</span><span class="ident">Section</span><span class="op">&gt;</span> {
    <span class="doccomment">/// No symbol flags.</span>
    <span class="prelude-val">None</span>,
    <span class="doccomment">/// ELF symbol flags.</span>
    <span class="ident">Elf</span> {
        <span class="doccomment">/// `st_info` field in the ELF symbol.</span>
        <span class="ident">st_info</span>: <span class="ident">u8</span>,
        <span class="doccomment">/// `st_other` field in the ELF symbol.</span>
        <span class="ident">st_other</span>: <span class="ident">u8</span>,
    },
    <span class="doccomment">/// Mach-O symbol flags.</span>
    <span class="ident">MachO</span> {
        <span class="doccomment">/// `n_desc` field in the Mach-O symbol.</span>
        <span class="ident">n_desc</span>: <span class="ident">u16</span>,
    },
    <span class="doccomment">/// COFF flags for a section symbol.</span>
    <span class="ident">CoffSection</span> {
        <span class="doccomment">/// `Selection` field in the auxiliary symbol for the section.</span>
        <span class="ident">selection</span>: <span class="ident">u8</span>,
        <span class="doccomment">/// `Number` field in the auxiliary symbol for the section.</span>
        <span class="ident">associative_section</span>: <span class="prelude-ty">Option</span><span class="op">&lt;</span><span class="ident">Section</span><span class="op">&gt;</span>,
    },
}
</code></pre></div>
</section></div></main><div id="rustdoc-vars" data-root-path="../../" data-current-crate="object" data-themes="ayu,dark,light" data-resource-suffix="" data-rustdoc-version="1.64.0-dev" ></div>
</body></html>